/**
 * Copyright (c) 2020 Guido Kramann
 *
 * This file is part of a library called AOGdogmaWEB - http://www.kramann.info/AOGdogmaWEB.html
 *
 * AOGdogmaWEB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * AOGdogmaWEB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the AOGdogmaWEB. If not, see <http://www.gnu.org/licenses/>.
*/


function Audiosystem()
{
  
   var instrument = []; //= (new Instrument()).init(SAMP,[57,60,64,71,72]);//.init(SAMP,TON);

   var audiocontext = null;
   var t=0;
   var dt=1/44100;
   var ANZPOLY = 100;
   var POS  = new Array(ANZPOLY);
   var MID  = new Array(ANZPOLY);
   var INS  = new Array(ANZPOLY);
   var DET  = new Array(ANZPOLY);
   var END  = new Array(ANZPOLY);

   var READY = false;

   this.isReady = function()
   {
       return READY;
   }

   function iabs(x)
   {
    if(x<0)
        return -x;
    else
        return x;
   }

   function midi2Frequency(midi)
   {
        if(midi<1.0)
            return 0.0; //Nullereignisse behandeln
  
        var freq69 = Math.pow(2.0,69.0/12.0);
        return Math.pow(2.0,midi/12.0)*440.0/freq69;
   }

   function prozess(e)   
   {
    var data_left  = e.outputBuffer.getChannelData(0);
    var data_right = e.outputBuffer.getChannelData(1);
/*    
    for(var k=0;k<data_left.length;k++)
    {
        data_left[k]=0;
        data_right[k]=0;
        data_left[k]=Math.sin(2.0*Math.PI*440*t);
        data_right[k]=Math.sin(2.0*Math.PI*660*t);
        t+=dt;
    }
*/
    for(var k=0;k<data_left.length;k++)
    {
        data_left[k]=0;
    }
    for(var i=0;i<MID.length;i++)
    {
        if(MID[i]>0)
        {
            for(var k=0;k<data_left.length;k++)
            {
                var LR = instrument[INS[i]].evaluateLR(MID[i],POS[i]);


                if(LR!=null)
                {
                    data_left[k]+=LR[0];
                    data_right[k]+=LR[1];
                    //POS[i]+=instrument[INS[i]].getDT(MID[i]);
                    POS[i]+=DET[i];
                }
                else
                {
                    INS[i]=-1;
                    MID[i]=-1;
                    DET[i]=1.0;
                    POS[i]=0.0;
                    END[i]=0; //Nicht benutzt bisher

                    break;
                }
            }
        }
    }
    for(var k=0;k<data_left.length;k++)
    {
        t+=dt;
    }
   }

   function initialisiereAudiokontext()
   {
       audiocontext = new (window.AudioContext || window.webkitAudioContext)();
       //1. Param.: Erlaubte Puffergroessen: 256, 512, 1024, 2048, 4096, 8192, 16384
       //2. Param.: Anzahl der Input-Kanaele
       //3. Param.: Anzahl der Output-Kanaele
       node = audiocontext.createScriptProcessor(1024, 0, 2);
       node.onaudioprocess = function(e) { prozess(e) };
       node.connect(audiocontext.destination); //"play"

   }

   this.init = function(AP)
   {
    ANZPOLY = AP;
    //alert(SAMP.length+" "+SAMP[0].length+" "+SAMP[1].length);
    initialisiereAudiokontext();
    for(var i=0;i<POS.length;i++)
    {
           INS[II]=-1;
           MID[II]=-1;
           DET[II]=1.0;
           POS[II]=0.0;
           END[II]=0; //Nicht benutzt bisher
    }
    
    var instA = new Instrument();
    instA.init(SAMPXYLOPHONE3RIGHT,[67,72,79,84,91,96,103,108],0.25,0.12);//.init(SAMP,TON);
    var instB = new Instrument();
    instB.init(SAMPVIBRAPHONE3RIGHT,[53,57,60,64,67,71,74,77,81,84,88],0.1,0.1);//.init(SAMP,TON);
    var instC = new Instrument();
    instC.init(SAMPMARIMBAPHONE3RIGHT,[41,48,55,59,65,72,79,83,89,96],0.12,0.25);//.init(SAMP,TON);
    
    instrument = new Array(instA,instB,instC);
    
    READY = true;
   }

   var II=0;
   this.play = function(inst,midi)
   {
    INS[II]=inst;
    MID[II]=midi;
    DET[II]=instrument[inst].getDT(midi);
    POS[II]=0.0;
    END[II]=0; //Nicht benutzt bisher
    II++;
    II%=POS.length;
   }
}
